// GSV4console.cpp : Defines the entry point for the console application.
//

/* ******** Bedienung des Testprograms: Tastatureingaben:
g: Eingangseigenschaften des einzugebenden Kanals
y: Staendige Messwertuebetragung starten
x: Staendige Messwertuebetragung stoppen
f: Datebrate
l: Einstellugen laden
s: Einstellugen speichern
m: Modus lesen
n: Anzeigenormierung
z: Nullsetzen des einzugebenden Kanals 1..4 oder 0: Alle Kanaele
*/

/* #include <stdio.h>
#include <conio.h>
#include <iostream.h>
#include<Windows.h>
#include "MEGSV4.H" */

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <Windows.h>
#include "MEGSV4w32.h"

using namespace std;

#define READ_MULTI	//Messwerte blockweise lesen
#define MAINLOOPDELAY 2
#ifdef GSV4_BLUETOOTH_OLD	//Bei aelteren GSV-4BT: Mit Handshake und verlaengertem Activate-Timeout oeffnen
	#define OPEN_FLAGS ACTEX_FLAG_HANDSHAKE|ACTEX_FLAG_WAIT_EXTENDED
#else
	#define OPEN_FLAGS 0
#endif

//int main(int argc, char* argv[])
int _tmain(int argc, _TCHAR* argv[])
{
	int Comnr, ret, in, mode, gain,i,j;
	long Baud;
	double Wert[4], Dtmp, nor[4];
	double Warr[2048];
	unsigned int Count=0;
	int gelesen;
	char Taste=0, t=0;
	char Ser[10];
//Begin:
	cout<<"ComNr. eingeben: "<<endl<<flush;
	cin>>Comnr;
	cout<<"Baudrate eingeben: "<<endl<<flush;
	cin>>Baud;
	ret= GSV4activateExtended(Comnr, Baud, 512, OPEN_FLAGS);	//AB HIER: Obligatorischer GSV-4-START. Versuche, GSV-4 zu oeffnen
	cout<<"Ergebnis: "<<ret<<endl<<flush;
	if(ret==GSV_ERROR)
	{
		cout<<"GSV4getLastError: "<<GSV4getLastError(Comnr)<<endl<<flush; //bei Error:
		printf(" Beliebige Taste...\n\n");
		_getch(); fflush(stdout); fflush(stdin);	//Errorcode anzeigen und Ende
		exit(0);
	}
	Sleep(500);
	mode= GSV4getMode(Comnr);	//sonst: erstmal Modus lesen
	cout<<endl<<"GSV4getMode: "<<mode<<endl<<flush;
	if(mode==0)		//wenn GSV-4 im Modus 0: 
	{
		Sleep(500);	//500ms warten 
		cout<<"GSV4setMode: "<<GSV4setMode(Comnr,1,"berlin")<<endl<<flush; //und dann Modus 1 einstellen
	}	//BIS HIER: Obligatorischer GSV-4-START
	Sleep(400);
	cout<<"GSV4readSerialNo: "<<GSV4readSerialNo(Comnr,Ser); //SerNo lesen 
	cout<<" No: "<<Ser<<endl<<flush;
	for(i=0;i<4;i++)
	{
		Sleep(200);
		nor[i]=GSV4DispGetNorm(Comnr,i+1);	//Anzeigennormierung aller 4 Eingaenge lesen
		cout<<"GSV4DispGetNorm("<<i+1<<"): "<<nor[i]<<endl<<flush;
	}
	printf(" Beliebige Taste...\n\n");
	_getch(); fflush(stdout); fflush(stdin);

	do	//MAINLOOP
	{
#ifdef READ_MULTI
		ret= GSV4readMultiple(Comnr,0,Warr,400,&gelesen);	//versuche, Messwerte aus dem dll-Buffer zu holen
#else
		ret= GSV4readAll(Comnr, &Wert[0], &Wert[1], &Wert[2], &Wert[3]);
#endif
		if(ret==GSV_TRUE)	//wenn Messwerte aus dem dll-Buffer geholt wurden:
		{
#ifdef READ_MULTI
			for(i=0;i<(gelesen/4);i++)	//diese Messwerte alle anzeigen
			{
				for(j=0;j<4;j++)
					Wert[j]= Warr[(i*4)+j]*nor[j];
				printf("W1: %.5lf W2: %.5lf W3: %.5lf W4: %.5lf\n",Wert[0],Wert[1],Wert[2],Wert[3]);
			}
#else
			printf("W1: %.5lf W2: %.5lf W3: %.5lf W4: %.5lf\n",Wert[0]*nor[0],Wert[1]*nor[1],Wert[2]*nor[2],Wert[3]*nor[3]);
#endif
		}
		else
		{
			Sleep(MAINLOOPDELAY);	//warten, um OS zu entlasten
			if(ret==GSV_ERROR)
				printf("Error!\n");	//dll meldet Fehler
		}
		if(_kbhit())	//Tastatureingabe
		{
			Taste= _getche();
			switch(Taste) //Eingaben auswerten...
			{
			case 'c':	//GSV-4-internen Skalierungsfaktor lesen
				cout<<" Kanal (1..4): "<<endl<<flush;
				cin>>in;
				cout<<" Gain: "<<endl<<flush;
				cin>>gain;
				cout<<"MeGSV4getScale: "<<MeGSV4getScale(Comnr,in,gain)<<endl<<flush;
				break;
			case 'g':
				cout<<" Kanal (1..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4getGain: "<<GSV4getGain(Comnr,in)<<endl<<flush;
				cout<<"Gain aendern? (j / n): "<<flush;
				cin>>t;
				if(t=='j')
				{
					cout<<endl<<"Neue Gain: "<<flush;
					cin>>gain;
					cout<<endl<<"GSV4setGain: "<<GSV4setGain(Comnr, in, gain)<<endl<<flush;
					cout<<"GSV4getGain: "<<GSV4getGain(Comnr,in)<<endl<<flush;
				} break;
			case 'y':
				cout<<"GSV4startTX: "<<GSV4startTX(Comnr)<<endl<<flush; break;
			case 'x':
				cout<<"GSV4stopTX: "<<GSV4stopTX(Comnr)<<endl<<flush; break;
			case 'f':
				Dtmp= GSV4readFreq(Comnr);
				cout<<"GSV4readFreq: "<<Dtmp<<endl<<flush;
				cout<<"Freq aendern? (j / n): "<<flush;
				cin>>t;
				if(t=='j')
				{
					cout<<endl<<"Neue Freq: "<<flush;
					cin>>Dtmp;
					cout<<endl<<"GSV4writeFreq: "<<GSV4writeFreq(Comnr, Dtmp)<<endl<<flush;
					cout<<" GSV4readFreq: "<<GSV4readFreq(Comnr)<<endl<<flush;
				} break;
			case 'l':
				cout<<"Satz-No (1..3): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4getAll: "<<GSV4getAll(Comnr,in)<<endl<<flush; break;
			case 'm':
				cout<<"GSV4getMode: "<<GSV4getMode(Comnr)<<endl<<flush; break;
			case 'n':
				cout<<" Kanal (1..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4DispGetNorm: "<<GSV4DispGetNorm(Comnr,in)<<endl<<flush;
				cout<<"Norm aendern? (j / n): "<<flush;
				cin>>t;
				if(t=='j')
				{
					cout<<endl<<"Neue Norm: "<<flush;
					cin>>Dtmp;
					cout<<endl<<"GSV4DispSetNorm: "<<GSV4DispSetNorm(Comnr, in, Dtmp)<<endl<<flush;
					nor[in-1]= GSV4DispGetNorm(Comnr,in);
					cout<<" GSV4DispGetNorm: "<<nor[in-1]<<endl<<flush;
				} break;
			case 's':
				cout<<"Satz-No (1..3): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4saveAll: "<<GSV4saveAll(Comnr,in)<<endl<<flush; break;
			case 'r':
				cout<<"kanal (1..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4read: "<<GSV4read(Comnr, in, &Dtmp);
				cout<<"Wert: "<<Dtmp<<endl<<flush; break;
			case 'v':
				cout<<"GSV4getValue: "<<GSV4getValue(Comnr)<<endl<<flush; break;
			case 'z':
				cout<<"kanal (0..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4setZero: "<<GSV4setZero(Comnr,in)<<endl<<flush;
				cout<<"GSV4clearDLLbuffer: "<<GSV4clearDLLbuffer(Comnr)<<endl<<flush; break;
			default: break;
			}
			printf(" Beliebige Taste...\n\n");
			_getch(); fflush(stdout); fflush(stdin);
		}

	} while(Taste!='q'); //Ende Mainloop

	ret= GSV4release(Comnr);	// freigeben
	return 0;
}

